<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';
//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//dynemic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";

$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();
if (
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);


$function_type = trim($postdata['function_type']);

function fetchStudentRegistration($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid,$function_type, $branch_id,$class_id,$section_id,  $search_string, $limit, $offset)
{
    $Faculty_Codes = $conn_rjllearning_specific->prepare("SELECT id FROM faculty_info WHERE userid = ? AND institution_id = ? AND branch_id = ? AND status = ?");
    $Faculty_Codes->execute(array($userid, $institution_id, $branch_id,1));

    // Fetch a single row instead of all
    $result_faculty = $Faculty_Codes->fetch(PDO::FETCH_ASSOC);

    // Check if the faculty exists
    if ($result_faculty === false) {
        errorreturn("Faculty Not Found.");
    }

    // Retrieve the faculty_id from the result
    $faculty_id = $result_faculty['id'];
    $teacher_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);
    $class_section_subjects  = $teacher_data['class_section_subjects'];
    $class_incharge_roles = $teacher_data['class_incharge_roles'];
    $staff_access_modules = $teacher_data['staff_access_modules'];

    $check_faculty_status = checkFacultyModuleGranted($function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules, $class_id, $section_id, null, $conn_rjllearning);
    if($check_faculty_status == false){
        errorreturn("Access denied: You do not have the required permissions.");
    }

    $sql = "SELECT COUNT(id) AS total_rows FROM student_registration WHERE  institution_id = ? and branch_id=? ";
    $array_params = array($institution_id,$branch_id);
    
    // $sql_append_data = facultyFilterQueryAppend($sql, $array_params, $function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules, null, null, null,$conn_rjllearning, 1, 1, 1, 1);

    // // Get the modified SQL and merged array of parameters
    // $validate_student = $sql_append_data['sql'];  // Get the modified SQL query
    // $array_params =  $sql_append_data['array_params'];

    $validate_student = $conn_rjllearning_specific->prepare($sql);
    $validate_student->execute($array_params);

    $result_total = $validate_student->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {

        $sql = "SELECT * FROM  student_registration WHERE institution_id = ? and branch_id=? and status=?  ORDER BY id DESC";
        $array_params = [$institution_id,$branch_id,1];
        if ($search_string != null) {
            $sql .= " AND (reg_no LIKE ? OR name LIKE ? OR mobile LIKE ? OR email LIKE ?)   ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
       
    } else {
        $sql = "SELECT * FROM  student_registration WHERE institution_id = ? and branch_id=? and status=? ";
        $array_params = [$institution_id,$branch_id,1];
        if ($search_string != null) {
            $sql .= " AND (reg_no LIKE ? OR name LIKE ? OR mobile LIKE ? OR email LIKE ?)   ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%';
        }
        
        $sql .= " order by id desc, date_added desc ";
        $sql .= "LIMIT " . $offset . " ," . $limit . "";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();
    $data = array();
    foreach ($result as $rows) {
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['for_class']);
        $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        $current_info = getClass($conn_rjllearning_specific, $institution_id, $rows['current_class']);

        $data[] = array(
            'reg_id' => $rows['id'], 'branch_id' => $branch_info, 'name' => $rows['name'], 'reg_no' => $rows['reg_no'], 'fathername' => $rows['fathername'],
            'mothername' => $rows['mothername'], 'mobile' => $rows['mobile'], 'email' => $rows['email'], 'address_line_1' => $rows['address_line_1'], 'city' => $rows['city'], 'pincode' => $rows['pincode'], 'dob' => $rows['dob'], 'gender' => $rows['gender'],
            'reg_fees' => $rows['reg_fees'], 'paid_through' => $rows['paid_through'], 'refrence_number' => $rows['refrence_number'], 'for_class' => $class_info, 'last_school' => $rows['last_school'], 'current_class' => $current_info
        );
    }
   if (count($result) < 50) {
        return array('total_rows' => $totalrows, 'registration_info' => $data, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'registration_info' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_student_registration") {
    // $institution_id = trim($postdata['institution_id']);
    // $branch_id = trim($postdata['branch_id']);
    // if (isset($postdata['branch_id']) and !empty($postdata['branch_id'])) {
    //     $branch_id = trim($postdata['branch_id']);
    // } else {
    //     $branch_id = null;
    // }
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }
    
        if (isset($postdata['section_id']) and !empty($postdata['section_id']) and trim($postdata['section_id'])) {
        $section_id = trim($postdata['section_id']);
    } else {
        $section_id = 'all';
    }

    if (isset($postdata['class_id']) and !empty($postdata['class_id']) and trim($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = 'all';
    }

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    $limit = $postdata['limit'];
    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
    } else {
        $offset = null;
    }
    
    $success['data'] = fetchStudentRegistration($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid,$function_type, $branch_id,$class_id,$section_id, $search_string, $limit, $offset);
    successreturn($success);
}
